class CAIN(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  encoder : __torch__.model.cain.cain.Encoder
  decoder : __torch__.model.cain.cain.Decoder
  def forward(self: __torch__.model.cain.cain.CAIN,
    x1: Tensor,
    x2: Tensor) -> Tuple[Tensor, Tensor]:
    _0 = self.decoder
    _1 = self.encoder
    mean = torch.mean(torch.mean(x1, [2], True), [3], True)
    input = torch.sub_(x1, mean)
    mean0 = torch.mean(torch.mean(x2, [2], True), [3], True)
    input0 = torch.sub_(x2, mean0)
    _2 = (_0).forward((_1).forward(input, input0, ), )
    mi = torch.div(torch.add(mean, mean0), CONSTANTS.c0)
    return (torch.add_(_2, mi), mi)
class Encoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  shuffler : __torch__.torch.nn.modules.pixelshuffle.PixelUnshuffle
  interpolate : __torch__.model.cain.common.Interpolation
  def forward(self: __torch__.model.cain.cain.Encoder,
    input: Tensor,
    input1: Tensor) -> Tensor:
    _3 = self.interpolate
    _4 = self.shuffler
    _5 = (_3).forward((_4).forward(input, ), (_4).forward1(input1, ), )
    return _5
class Decoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  shuffler : __torch__.torch.nn.modules.pixelshuffle.PixelShuffle
  def forward(self: __torch__.model.cain.cain.Decoder,
    argument_1: Tensor) -> Tensor:
    _6 = (self.shuffler).forward(argument_1, )
    return _6
