class Interpolation(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  headConv : __torch__.torch.nn.modules.conv.Conv2d
  body : __torch__.torch.nn.modules.container.___torch_mangle_384.Sequential
  tailConv : __torch__.torch.nn.modules.conv.___torch_mangle_385.Conv2d
  def forward(self: __torch__.model.cain.common.Interpolation,
    argument_1: Tensor,
    argument_2: Tensor) -> Tensor:
    _0 = self.tailConv
    _1 = self.body
    _2 = self.headConv
    input = torch.cat([argument_1, argument_2], 1)
    _3 = (_2).forward(input, )
    input0 = torch.add_((_1).forward(_3, ), _3)
    return (_0).forward(input0, )
class ResidualGroup(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  body : __torch__.torch.nn.modules.container.___torch_mangle_186.Sequential
  def forward(self: __torch__.model.cain.common.ResidualGroup,
    argument_1: __torch__.torch.nn.modules.activation.___torch_mangle_366.LeakyReLU,
    argument_2: Tensor) -> Tensor:
    _4 = (self.body).forward(argument_1, argument_2, )
    return torch.add_(_4, argument_2)
class RCAB(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  body : __torch__.torch.nn.modules.container.___torch_mangle_6.Sequential
  def forward(self: __torch__.model.cain.common.RCAB,
    argument_1: __torch__.torch.nn.modules.activation.___torch_mangle_366.LeakyReLU,
    argument_2: Tensor) -> Tensor:
    _5 = (self.body).forward(argument_1, argument_2, )
    return torch.add_(_5, argument_2)
class ConvNorm(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  reflection_pad : __torch__.torch.nn.modules.padding.ReflectionPad2d
  conv : __torch__.torch.nn.modules.conv.___torch_mangle_0.Conv2d
  def forward(self: __torch__.model.cain.common.ConvNorm,
    argument_1: Tensor) -> Tensor:
    _6 = self.conv
    _7 = (self.reflection_pad).forward(argument_1, )
    return (_6).forward(_7, )
class CALayer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  avg_pool : __torch__.torch.nn.modules.pooling.AdaptiveAvgPool2d
  conv_du : __torch__.torch.nn.modules.container.Sequential
  def forward(self: __torch__.model.cain.common.CALayer,
    argument_1: Tensor) -> Tensor:
    _8 = self.conv_du
    _9 = (self.avg_pool).forward(argument_1, )
    out = torch.mul(argument_1, (_8).forward(_9, ))
    return out
